package garage.garage;

import java.lang.reflect.Method;
import java.util.List;

public class Task {

    private Object obj;
    private String method;
    private List<Object> args;
    private Integer t;

    public Task(Object obj, String method, List<Object> args, Integer t) {
        this.obj = obj;
        this.method = method;
        this.args = args;
        this.t = t;
    }

    //METHODS
    public void execute() throws ExecutionFailedException {
        Class[] mArgs = new Class[0];

        if(args != null){
            mArgs = new Class[args.size()];
            for(Integer i = 0; i < args.size(); i++) mArgs[i] = args.get(i).getClass();
        }

        try {
            System.out.println("Calling method " + method + " of class -> " + obj.getClass());
            Method m = obj.getClass().getMethod(method, mArgs);
            if(args == null) m.invoke(obj, null);
            else m.invoke(obj, args.toArray());
        }catch(Exception e){
            throw new ExecutionFailedException(e.getMessage());
        }
    }

    // GETTERS

    public Object getObj() {
        return obj;
    }

    public String getMethod() {
        return method;
    }

    public List<Object> getArgs() {
        return args;
    }

    public Integer getT() {
        return t;
    }
}
