package garage.vehicle;

import garage.vehicle.part.brake.BrakeType;
import garage.vehicle.part.engine.EngineModel;
import garage.vehicle.part.frame.FrameType;

public enum VehicleModel {

    FIAT_500(VehicleBrand.FIAT, "500", EngineModel.TDI_M_D, FrameType.MICRO, BrakeType.PAD_FX200, 4),
    PEUGEOT_5008(VehicleBrand.PEUGEOT, "5008", EngineModel.TDI_A_P, FrameType.SUV, BrakeType.DISC_FX200, 4);

    private final VehicleBrand brand;
    private final String name;
    private final EngineModel engineModel;
    private final FrameType frameType;
    private final BrakeType brakesType;
    private final Integer nbOfWheels;

    VehicleModel(VehicleBrand brand, String name, EngineModel engineModel, FrameType frameType, BrakeType brakesType, Integer nbOfWheels){
        this.brand = brand;
        this.name = name;
        this.engineModel = engineModel;
        this.frameType = frameType;
        this.brakesType = brakesType;
        this.nbOfWheels = nbOfWheels;
    }

    public VehicleBrand getBrand() {
        return brand;
    }

    public String getName() {
        return name;
    }

    public EngineModel getEngineModel() {
        return engineModel;
    }

    public FrameType getFrameType() {
        return frameType;
    }

    public BrakeType getBrakesType() {
        return brakesType;
    }

    public Integer getNbOfWheels() {
        return nbOfWheels;
    }
}
